#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

#define VE_fl 0x04 //video enable flag
#define IE_fl 0x40 //interrupt enable flag
#define IR_fl 0x20 //interrupt request flag

/********************************************************************/

class I8275 : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
  unsigned char takt; //  ,       
  unsigned char SREG_reg; //   
  unsigned char screen_comp1_reg; //  
  unsigned char screen_comp2_reg; //  
  unsigned char screen_comp3_reg; //  
  unsigned char screen_comp4_reg; //  
  unsigned char lp_char_numb_reg; //   ( )
  unsigned char lp_row_numb_reg;  //   ( )
  unsigned char cur_char_numb_reg; //  
  unsigned char cur_row_numb_reg;  //  
  unsigned char display_cmd; //       
  unsigned char hrtc_cnt; //    
  unsigned char LC04_cnt; //     
  unsigned char row_cnt;  //     ( )  
  unsigned char char_cnt; //     ( )  
  unsigned char row_buf[80][2]; //0..79 chars       
  unsigned char row_buf_cnt[2]; // /    
  unsigned char row_fifo[16][2]; //0..15 atributs       ( )
  unsigned char row_fifo_cnt[2]; // /    
  unsigned char current_row; // 0/1 -       ,   
  unsigned char set_dataZ_takt; //  SREG       ,         Z   
  unsigned char dma_burst_cnt;  //     DMA    
  unsigned char clk_between_dma_cnt; //      DMA 
  unsigned char cursor_blink_cnt; //    

  
private: 
 unsigned char get_data();
 void set_LC04(ABSTIME time,unsigned char tmp);
 void set_CC06(ABSTIME time,unsigned char tmp);
 void set_data(ABSTIME time,unsigned char tmp);
 void set_data_Z(ABSTIME time);
 void set_adr(ABSTIME time,unsigned char tmp);
 void set_adr_Z(ABSTIME time);
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *pin_CLK; 
  IDSIMPIN *pin_cs; 
  IDSIMPIN *pin_nRD; 
  IDSIMPIN *pin_nWR; 
  IDSIMPIN *pin_A0; 
  IDSIMPIN *pin_D0; 
  IDSIMPIN *pin_D1; 
  IDSIMPIN *pin_D2; 
  IDSIMPIN *pin_D3; 
  IDSIMPIN *pin_D4; 
  IDSIMPIN *pin_D5; 
  IDSIMPIN *pin_D6; 
  IDSIMPIN *pin_D7; 
  IDSIMPIN *pin_DRQ; 
  IDSIMPIN *pin_nDACK; 
  IDSIMPIN *pin_IRQ; 
  IDSIMPIN *pin_LPEN; 
  IDSIMPIN *pin_LTEN; 
  IDSIMPIN *pin_LC0;
  IDSIMPIN *pin_LC1;
  IDSIMPIN *pin_LC2;
  IDSIMPIN *pin_LC3;
  IDSIMPIN *pin_LC4;
  IDSIMPIN *pin_CC0;
  IDSIMPIN *pin_CC1;
  IDSIMPIN *pin_CC2;
  IDSIMPIN *pin_CC3;
  IDSIMPIN *pin_CC4;
  IDSIMPIN *pin_CC5;
  IDSIMPIN *pin_CC6;
  IDSIMPIN *pin_LA0;
  IDSIMPIN *pin_LA1;
  IDSIMPIN *pin_VSP;
  IDSIMPIN *pin_HLGT;
  IDSIMPIN *pin_RVV;
  IDSIMPIN *pin_GPA0;
  IDSIMPIN *pin_GPA1;
  IDSIMPIN *pin_HRTC;
  IDSIMPIN *pin_VRTC;
}; 

HANDLE hProcessHeap;

extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new I8275;   
}   

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    delete (I8275*)model; 
}   
       
int I8275::isdigital(CHAR *pinname)   {   
        return 1;   
}   

/********************************************************************/

void I8275::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
        
//    instance->log("START");
    hProcessHeap=GetProcessHeap();
  
  takt=0x0;
  SREG_reg=0x0;
  screen_comp1_reg=0x0;
  screen_comp2_reg=0x0;
  screen_comp3_reg=0x0;
  screen_comp4_reg=0x0;
  lp_char_numb_reg=0x0;
  lp_row_numb_reg=0x0;
  cur_char_numb_reg=0x0;
  cur_row_numb_reg=0x0;
  display_cmd=0;
  hrtc_cnt=0;
  LC04_cnt=0;
  row_cnt=0;
  char_cnt=0;
  row_buf_cnt[0]=0;
  row_buf_cnt[1]=0;
  row_fifo_cnt[0]=0;
  row_fifo_cnt[1]=0;
  current_row=0;
  set_dataZ_takt=0;
  dma_burst_cnt=0;
  clk_between_dma_cnt=0;
  cursor_blink_cnt=0;

    pin_CLK = instance->getdsimpin("CCLK", true); pin_CLK->setstate(0,1,FLT);
    pin_cs = instance->getdsimpin("$CS$", true);  pin_cs->setstate(0,1,FLT);
    pin_nRD = instance->getdsimpin("$RD$", true); pin_nRD->setstate(0,1,FLT);
    pin_nWR = instance->getdsimpin("$WR$", true); pin_nWR->setstate(0,1,FLT);
    pin_A0 = instance->getdsimpin("A0", true);    pin_A0->setstate(0,1,FLT);
    pin_D0 = instance->getdsimpin("D0", true);
    pin_D1 = instance->getdsimpin("D1", true);
    pin_D2 = instance->getdsimpin("D2", true);
    pin_D3 = instance->getdsimpin("D3", true);
    pin_D4 = instance->getdsimpin("D4", true);
    pin_D5 = instance->getdsimpin("D5", true);
    pin_D6 = instance->getdsimpin("D6", true);
    pin_D7 = instance->getdsimpin("D7", true);    set_data_Z(0);
    pin_DRQ = instance->getdsimpin("DRQ", true);    pin_DRQ->setstate(0,1,SLO);
    pin_nDACK = instance->getdsimpin("$DACK$", true); pin_nDACK->setstate(0,1,FLT);
    pin_IRQ = instance->getdsimpin("IRQ", true);    pin_IRQ->setstate(0,1,SLO);
    pin_LPEN = instance->getdsimpin("LPEN", true);    pin_LPEN->setstate(0,1,FLT);
    pin_LTEN = instance->getdsimpin("LTEN", true);    pin_LTEN->setstate(0,1,SLO);
    pin_LC0   = instance->getdsimpin("LC0", true);    pin_LC0->setstate(0,1,SLO);
    pin_LC1   = instance->getdsimpin("LC1", true);    pin_LC1->setstate(0,1,SLO);
    pin_LC2   = instance->getdsimpin("LC2", true);    pin_LC2->setstate(0,1,SLO);
    pin_LC3   = instance->getdsimpin("LC3", true);    pin_LC3->setstate(0,1,SLO);
    pin_CC0   = instance->getdsimpin("CC0", true);    pin_CC0->setstate(0,1,SLO);
    pin_CC1   = instance->getdsimpin("CC1", true);    pin_CC1->setstate(0,1,SLO);
    pin_CC2   = instance->getdsimpin("CC2", true);    pin_CC2->setstate(0,1,SLO);
    pin_CC3   = instance->getdsimpin("CC3", true);    pin_CC3->setstate(0,1,SLO);
    pin_CC4   = instance->getdsimpin("CC4", true);    pin_CC4->setstate(0,1,SLO);
    pin_CC5   = instance->getdsimpin("CC5", true);    pin_CC5->setstate(0,1,SLO);
    pin_CC6   = instance->getdsimpin("CC6", true);    pin_CC6->setstate(0,1,SLO);
    pin_LA0   = instance->getdsimpin("LA0", true);    pin_LA0->setstate(0,1,SLO);
    pin_LA1   = instance->getdsimpin("LA1", true);    pin_LA1->setstate(0,1,SLO);
    pin_VSP   = instance->getdsimpin("VSP", true);    pin_VSP->setstate(0,1,SLO);
    pin_HLGT  = instance->getdsimpin("HLGT", true);   pin_HLGT->setstate(0,1,SLO);
    pin_RVV   = instance->getdsimpin("RVV", true);    pin_RVV->setstate(0,1,SLO);
    pin_GPA0  = instance->getdsimpin("GPA0", true);   pin_GPA0->setstate(0,1,SLO);
    pin_GPA1  = instance->getdsimpin("GPA1", true);   pin_GPA1->setstate(0,1,SLO);
    pin_HRTC  = instance->getdsimpin("HRTC", true);   pin_HRTC->setstate(0,1,SHI);
    pin_VRTC  = instance->getdsimpin("VRTC", true);   pin_VRTC->setstate(0,1,SHI);
}   
       
void I8275::runctrl(RUNMODES mode)  {   

}   
       
       
void I8275::actuate(REALTIME time,ACTIVESTATE newstate) {   

}   
       
BOOL I8275::indicate(REALTIME time,ACTIVEDATA *data)   {      
  return TRUE;
}   
//    Z       
void I8275::set_data_Z(ABSTIME time)
{
 pin_D0->setstate(time,1,FLT);   
 pin_D1->setstate(time,1,FLT);   
 pin_D2->setstate(time,1,FLT);   
 pin_D3->setstate(time,1,FLT);   
 pin_D4->setstate(time,1,FLT);   
 pin_D5->setstate(time,1,FLT);   
 pin_D6->setstate(time,1,FLT);   
 pin_D7->setstate(time,1,FLT);   
}
//    
unsigned char I8275::get_data()
{
unsigned char tmp=0;
 if (ishigh(pin_D0->istate())) tmp|=0x01;
 if (ishigh(pin_D1->istate())) tmp|=0x02;
 if (ishigh(pin_D2->istate())) tmp|=0x04;
 if (ishigh(pin_D3->istate())) tmp|=0x08;
 if (ishigh(pin_D4->istate())) tmp|=0x10;
 if (ishigh(pin_D5->istate())) tmp|=0x20;
 if (ishigh(pin_D6->istate())) tmp|=0x40;
 if (ishigh(pin_D7->istate())) tmp|=0x80;
 return tmp;
}
//    ,     mode0/mode1
void I8275::set_LC04(ABSTIME time,unsigned char tmp)
{
if (screen_comp4_reg&0x80) //  mode0/mode1
{ // mode1
  if (tmp==0) tmp=screen_comp3_reg&0x0f;
   else
   {
    if (tmp==(screen_comp3_reg&0x0f)) tmp=0;
     else tmp--;
   }
}// else mode0

  if (tmp&0x01) pin_LC0->setstate(time,1,SHI); else pin_LC0->setstate(time,1,SLO);
  if (tmp&0x02) pin_LC1->setstate(time,1,SHI); else pin_LC1->setstate(time,1,SLO);
  if (tmp&0x04) pin_LC2->setstate(time,1,SHI); else pin_LC2->setstate(time,1,SLO);
  if (tmp&0x08) pin_LC3->setstate(time,1,SHI); else pin_LC3->setstate(time,1,SLO);
}
//   
void I8275::set_CC06(ABSTIME time,unsigned char tmp)
{
  if (tmp&0x01) pin_CC0->setstate(time,1,SHI); else pin_CC0->setstate(time,1,SLO);
  if (tmp&0x02) pin_CC1->setstate(time,1,SHI); else pin_CC1->setstate(time,1,SLO);
  if (tmp&0x04) pin_CC2->setstate(time,1,SHI); else pin_CC2->setstate(time,1,SLO);
  if (tmp&0x08) pin_CC3->setstate(time,1,SHI); else pin_CC3->setstate(time,1,SLO);
  if (tmp&0x10) pin_CC4->setstate(time,1,SHI); else pin_CC4->setstate(time,1,SLO);
  if (tmp&0x20) pin_CC5->setstate(time,1,SHI); else pin_CC5->setstate(time,1,SLO);
  if (tmp&0x40) pin_CC6->setstate(time,1,SHI); else pin_CC6->setstate(time,1,SLO);
}
//   
void I8275::set_data(ABSTIME time,unsigned char tmp)
{
  if (tmp&0x01) pin_D0->setstate(time,1,SHI); else pin_D0->setstate(time,1,SLO);
  if (tmp&0x02) pin_D1->setstate(time,1,SHI); else pin_D1->setstate(time,1,SLO);
  if (tmp&0x04) pin_D2->setstate(time,1,SHI); else pin_D2->setstate(time,1,SLO);
  if (tmp&0x08) pin_D3->setstate(time,1,SHI); else pin_D3->setstate(time,1,SLO);
  if (tmp&0x10) pin_D4->setstate(time,1,SHI); else pin_D4->setstate(time,1,SLO);
  if (tmp&0x20) pin_D5->setstate(time,1,SHI); else pin_D5->setstate(time,1,SLO);
  if (tmp&0x40) pin_D6->setstate(time,1,SHI); else pin_D6->setstate(time,1,SLO);
  if (tmp&0x80) pin_D7->setstate(time,1,SHI); else pin_D7->setstate(time,1,SLO);
}
//   
void I8275::simulate (ABSTIME time,DSIMMODES mode) {      
unsigned char tmp;
//     Z
//    callback,   ,     
  if (set_dataZ_takt) 
  {
//instance->log("i8275: read SREG_reg %x",SREG_reg);
    set_dataZ_takt=0; 
    set_data_Z(time);
  }
// CS==0,      
  if (pin_cs->isinactive())
   {
// SREG,    ,   return
    if (pin_nRD->isnegedge()&pin_A0->isactive()) {set_data(time,SREG_reg); SREG_reg&=~IR_fl; return; }
    if (pin_nRD->isposedge()&pin_A0->isactive()) {set_dataZ_takt=1; return; }
//   
    if (pin_A0->isactive()&pin_nWR->isposedge()) 
     {
      tmp=get_data();
//instance->log("i8275: write reg %x",tmp);
//      /( )
      switch(tmp&0xe0)
       {
       case 0: //reset cmd, next 4 data param
         if (tmp==0) 
         {
          takt=1;//2,3,4   //   
          SREG_reg&=~VE_fl;
          SREG_reg&=~IE_fl;
          pin_DRQ->setstate(time,1,SLO);
          display_cmd=0;
         }
         break;
       case 0x20: //start display cmd, next 0 data param
         display_cmd=tmp;
instance->log("i8275: start display cmd %x",tmp);
         SREG_reg|=VE_fl;
         SREG_reg|=IE_fl;
         takt=0;
         break;
       case 0x40: //stop display cmd, next 0 data param
         if (tmp==0x40) 
         {
          takt=0;
          SREG_reg&=~VE_fl;
          SREG_reg&=~IE_fl;
         }
instance->log("i8275: stop display cmd");
         break;
       case 0x60: //read light pen cmd, next 2 data param
         if (tmp==0x60) takt=5;//6   //   
         break;
       case 0x80: //load cursor pos cmd, next 2 data param
         if (tmp==0x80) takt=7;//8   //   
         break;
       case 0xa0: //enable int cmd, next 0 data param
         if (tmp==0xa0) {SREG_reg|=IE_fl; takt=0;}
         break;
       case 0xc0: //disable int cmd, next 0 data param
         if (tmp==0xc0) {SREG_reg&=~IE_fl; takt=0;}
         break;
       case 0xe0: //preset counters cmd, next 0 data param
         if (tmp==0xe0) takt=0;
         break;
       }
     }//end if (pin_A0->isactive()&pin_nWR->isposedge()) 
     else
     {
//      ( )
      if (pin_A0->isinactive()&(pin_nWR->isposedge()|pin_nRD->isedge())) 
       switch(takt)
       {
       case 1:
         screen_comp1_reg=get_data();
instance->log("i8275: reset cmd screen_comp1 %x",screen_comp1_reg);
         takt++;
         break;
       case 2:
         screen_comp2_reg=get_data();
instance->log("i8275: reset cmd screen_comp2 %x",screen_comp2_reg);
         takt++;
         break;
       case 3:
         screen_comp3_reg=get_data();
instance->log("i8275: reset cmd screen_comp3 %x",screen_comp3_reg);
         takt++;
         break;
       case 4:
         screen_comp4_reg=get_data();
instance->log("i8275: reset cmd screen_comp4 %x",screen_comp4_reg);
         takt=0;
         break;
       case 5:
         if (pin_nRD->isnegedge()) set_data(time,lp_char_numb_reg); // ( )
         if (pin_nRD->isposedge()) {set_data_Z(time); takt++; }
         break;
       case 6:
         if (pin_nRD->isnegedge()) set_data(time,lp_row_numb_reg); // ( )
         if (pin_nRD->isposedge()) {set_data_Z(time); takt=0; }
         break;
       case 7:
         cur_char_numb_reg=get_data();
//instance->log("i8275: load cursor pos cmd cur_char_numb_reg %x",cur_char_numb_reg);
         takt++;
         break;
       case 8:
         cur_row_numb_reg=get_data();
//instance->log("i8275: load cursor pos cmd cur_row_numb_reg %x",cur_row_numb_reg);
         takt=0;
         break;
       }
     }
   }//end if (pin_cs->isinactive())
//       CLK       
  if (pin_CLK->isnegedge()&&(display_cmd&0x20))
  {
//   
    if (hrtc_cnt==0) 
    {
      pin_HRTC->setstate(time,1,SLO);
//          ( )
      if (row_cnt<((screen_comp2_reg&0x3f)+1)) pin_VSP->setstate(time,1,SLO);
//  
      if (row_cnt==0) 
      {
        pin_VRTC->setstate(time,1,SLO);
        set_LC04(time,LC04_cnt);
        char_cnt=0;
      }
//          7(   ,    >6),        
      if ((row_cnt<((screen_comp2_reg&0x3f)+1))&(((screen_comp3_reg>>4)&0x0f)>6))
      {
//     
       if ((LC04_cnt==0)|(LC04_cnt==(screen_comp3_reg&0x0f)))
          pin_VSP->setstate(time,1,SHI);
        else
          pin_VSP->setstate(time,1,SLO);
      }
    }
//        
    if (hrtc_cnt<((screen_comp1_reg&0x7f)+1))
    {
//   ,    ,  
      if (current_row)
        set_CC06(time,row_buf[char_cnt][0]);
      else
        set_CC06(time,row_buf[char_cnt][1]);
//    ,    ,       
      if ((LC04_cnt==(screen_comp3_reg&0x0f))&&(row_cnt==cur_row_numb_reg)&&(cursor_blink_cnt&0x02))//0x10 - 1/16  ,       
      {
       if (char_cnt==cur_char_numb_reg)
        {
//instance->log("i8275: char_cnt %d   row_cnt   %d   cursor_blink_cnt %d",char_cnt,row_cnt,cursor_blink_cnt);
//    ,  , , ,    
          pin_VSP->setstate(time,1,SLO);
// 
          pin_LTEN->setstate(0,1,SHI);
        }
       if (char_cnt==(cur_char_numb_reg+1))
        {
//instance->log("i8275: char_cnt %d   row_cnt   %d",char_cnt,row_cnt);
//    ,         7
          if (((screen_comp3_reg>>4)&0x0f)>6) pin_VSP->setstate(time,1,SHI);
          pin_LTEN->setstate(0,1,SLO);
        }
      }
//instance->log("i8275: char_cnt %d",char_cnt);
//    
      char_cnt++;
    }
//     
    hrtc_cnt++;
//     
    if (hrtc_cnt==((screen_comp1_reg&0x7f)+1))
    {
      pin_HRTC->setstate(time,1,SHI);
//     
      pin_VSP->setstate(time,1,SHI);
      LC04_cnt++;
//        ...
      if (LC04_cnt==((screen_comp3_reg&0x0f)+1)) 
      {
        LC04_cnt=0;
        row_cnt++;
//    
        if (row_cnt==((screen_comp2_reg&0x3f)+1))
        {
          pin_VRTC->setstate(time,1,SHI);
          pin_VSP->setstate(time,1,SHI);
          cursor_blink_cnt++;
        }
//    ,  +    
        if (row_cnt==(((screen_comp2_reg&0x3f)+1)+(((screen_comp2_reg>>6)&0x03)+1))) row_cnt=0; 
//           
        if (row_cnt==(screen_comp2_reg&0x3f)) {if (SREG_reg&IE_fl) SREG_reg|=IR_fl;}
//          DMA  
        if (row_cnt< (screen_comp2_reg&0x3f))
        {
//   DMA   (     ),     DMA
          if (row_buf_cnt[current_row]) 
          { 
            if (SREG_reg&VE_fl) pin_DRQ->setstate(time,1,SHI);
//    
            if (current_row) current_row=0; else current_row=1;
//,         ,   DMA
            row_buf_cnt[current_row]=0; 
//instance->log("i8275: new row ---------- DMA reqw - row_cnt %d    current_row %d",row_cnt,current_row);
          }
        }
        if (row_cnt==(((screen_comp2_reg&0x3f)+1)+(( screen_comp2_reg>>6)&0x03   ))) 
        {
          if (SREG_reg&VE_fl) pin_DRQ->setstate(time,1,SHI); 
          if (current_row) current_row=0; else current_row=1;
          row_buf_cnt[current_row]=0; 
//instance->log("i8275: DMA reqw - new row  %d",current_row);
        }
      }// end if (LC04_cnt==((screen_comp3_reg&0x0f)+1)) 
//   ,     mode0/mode1
      set_LC04(time,LC04_cnt);
//     
      char_cnt=0;
    }
//      (   CLK)
    if (hrtc_cnt==(((screen_comp1_reg&0x7f)+1)+(((screen_comp4_reg&0x0f)+1)*2))) hrtc_cnt=0;
//     DMA
    if (clk_between_dma_cnt) 
    {
      clk_between_dma_cnt++;
      switch(display_cmd>>2)
      {
       case 0x08: tmp=0+1; break;
       case 0x09: tmp=7+1; break;
       case 0x0a: tmp=15+1; break;//16 ?
       case 0x0b: tmp=23+1; break;
       case 0x0c: tmp=31+1; break;
       case 0x0d: tmp=39+1; break;
       case 0x0e: tmp=47+1; break;
       case 0x0f: tmp=55+1; break;
       default: tmp=0; break;
      }
//  ,     DMA
      if (clk_between_dma_cnt==tmp) {clk_between_dma_cnt=0; pin_DRQ->setstate(time,1,SHI);}
    }
  }//end if (pin_CLK->isnegedge()&&(display_cmd&0x20))
//  ,      DMA     WR _/-     DMA
  if ((display_cmd&0x20)&&(pin_nDACK->isinactive()&pin_nWR->isposedge()))
  {
//instance->log("i8275: dma_burst_cnt %d   row_buf_cnt[%d] %d",dma_burst_cnt,current_row,row_buf_cnt[current_row]);
    row_buf[row_buf_cnt[current_row]][current_row]=get_data();
    row_buf_cnt[current_row]++;
    dma_burst_cnt++;
//     DMA 
    switch(display_cmd&0x03)
    {
     case 0: tmp=1; break;
     case 1: tmp=2; break;
     case 2: tmp=4; break;
     case 3: tmp=8; break;
    }
//,   DMA  ,     
    if ((dma_burst_cnt==tmp)|(row_buf_cnt[current_row]==((screen_comp1_reg&0x7f)+1)))
    {
//   DMA  ,    DMA
      pin_DRQ->setstate(time,1,SLO); 
//          
      if (row_buf_cnt[current_row]!=((screen_comp1_reg&0x7f)+1)) 
        clk_between_dma_cnt=1;// 
      else
      {
        clk_between_dma_cnt=0;// ,    
//instance->log("i8275: row_buf_cnt[%d] %d    dma_burst_cnt %d",current_row,row_buf_cnt[current_row],dma_burst_cnt);
      }
      dma_burst_cnt=0;
    }
  }
}   
       
      
void I8275::callback(ABSTIME time,EVENTID eventid)   {   

}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new I8275;
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
  delete (I8275*)model;   
}   
               
void I8275::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *I8275::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *I8275::getdsimmodel(CHAR *)  {      
        return this;    
}   

void I8275::plot(ACTIVESTATE state)  {   

//  MessageBox(0, "plot", "Break", MB_OK);
}
        
void I8275::animate(INT element, ACTIVEDATA *data)  {    
//  MessageBox(0, "animate", "Break", MB_OK);

}   

BOOL I8275::actuate(WORD key, INT x, INT y, DWORD flags)  {
//  MessageBox(0, "ACTUATE2", "Break", MB_OK);
        return FALSE;    
}  
